#include "dcdialog.ch"
#include "dctree.ch"
#include "dcmsg.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"
#include "nls.ch"
#include "dll.ch"

#define COLOR_BUTTONS_FG            GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_BUTTONS_BG            GraMakeRGBColor( { 165, 195, 243 } )
#define COLOR_BUTTONS_FG_MOUSEOVER  GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_BUTTONS_BG_MOUSEOVER  GraMakeRGBColor( { 248, 186, 104 } )
#define COLOR_BUTTONS_BORDER        GraMakeRGBColor( {  80,  80,  80 } )
#define COLOR_TITLE_FG              GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_TITLE_BG              GraMakeRGBColor( {  78, 113, 255 } )
#define COLOR_INFO_FG               GraMakeRGBColor( {  80,  80,  80 } )
#define COLOR_ALERT_FG              GraMakeRGBColor( {   0,  70, 255 } )
#define COLOR_ALERT_BG              GraMakeRGBColor( { 250, 240, 160 } )
#define COLOR_RECTPBUTTON           GraMakeRGBColor( { 185, 220, 250 } )
#define COLOR_SAY_SEEK              GraMakeRGBColor( { 230,  50,   0 } )
#define COLOR_BROWSELIST            GraMakeRGBColor( { 160, 170, 190 } )
#define FONT_TREEMENU   "10.Arial.Narrow"
#define FONT_BUTTONS    "11.Alaska Crt"
#define FONT_TITLE      "12.Arial"
#define FONT_INFO       "10.Arial.Narrow"
#define FONT_ALERT      "12.Arial"
#define MAX_BUTTONS     4
#define FONT_SAY        "12.Arial.Narrow"
#define FONT_GET        "12.Alaska Crt"
#define FONT_ROWSPACE  22


procedure main
SET CHARSET TO OEM
SET CONFIRM ON
SET DELETE ON
SET SCORE OFF

    DO EXAMPLE

return


PROC appsys ; RETURN




PROCEDURE EXAMPLE
LOCAL aPos:={0,0},aSize:={0,0}
LOCAL GetOptions ,GetList:={}
LOCAL oButton,oColumn

PRIVATE oDialog,oDarea,nLastState:=0
PRIVATE oBrowse,lStatus


aSize:={ 900,500 }
aPos[1]:=10
aPos[2]:=100


USE ("TEST.DBF") ALIAS DBTEST NEW
dbgotop()

@  2,2 DCBROWSE oBrowse SIZE 120,18 ID "BROWSE" ;
                CURSORMODE XBPBRW_CURSOR_ROW ALIAS "DBTEST" ;
                PRESENTATION { { XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },      ;   /// Header FG Color
                            { XBP_PP_COL_HA_BGCLR, GRA_CLR_BACKGROUND }, ;   /// Header BG Color
                            { XBP_PP_COL_FA_FGCLR, GRA_CLR_YELLOW },     ;   /// Footer FG Color
                            { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },   ;   /// Footer BG Color
                            { XBP_PP_COL_DA_CELLHEIGHT, 20 }}            ;   /// Cell Height
                NOSIZECOLS

    DCBROWSECOL FIELD DBTEST->FIELD_1 Header "first field"   WIDTH 15 PARENT oBrowse OBJECT oColumn
    DCBROWSECOL FIELD DBTEST->FIELD_2 Header "second field"  WIDTH 10 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_3 Header "third"         WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_4 Header "four"          WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_2 Header "..."           WIDTH  8 PARENT oBrowse
    DCBROWSECOL FIELD DBTEST->FIELD_3 Header "..."           WIDTH  8 PARENT oBrowse

DCHOTKEY xbeK_ESC ACTION {|o| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList),DC_GetRefresh(GetList)}


/* ---- PUSHBUTTON ---- */
@ aSize[2]-40,15 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE aSize[1]-15,40 OBJECT oButtonLev0 PIXEL ;
                         COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON

    @ 0.2,5 DCPUSHBUTTON CAPTION "GETLIST LEVEL 1"  OBJECT oButton ;
                        ACTION {|| TEST_LEVEL1(GetList,oDialog,oButtonLev0) } SIZE 30,1.5 ;
                        PARENT oButtonLev0 TABSTOP


DCGETOPTIONS NOBUSY CONFIRM ;
             ROWSPACE (FONT_ROWSPACE)  SAYFONT (FONT_SAY)  GETFONT (FONT_GET) ;
             MINSIZE aSize[1],aSize[2] MAXSIZE aSize[1],aSize[2] ;
             TITLE "DEMO" ;
             BORDER XBPDLG_DLGBORDER ;
             CLOSEQUERY MSG {||.F.} ;
             HIDE

DCREAD GUI OPTIONS GetOptions PARENT @oDialog ;
       SETFOCUS "BROWSE" FIT EVAL {||oDialog:setPos( { aPos[1], aPos[2] }), oDialog:show() }


RETURN







STATIC FUNCTION TEST_LEVEL1 (oGetList,oDlg,oButtonLev0)
LOCAL GetOptions ,GetList:={}
LOCAL aSize,aPos,nColPos,nRowPos,oColumn,oColumn2,oCell,aRect,nHeadHeight,nRowHeight
LOCAL nT,nX,nY,oBarEdit,oDialogNew
LOCAL oButtonLev1,oRectangle
LOCAL cVar1,cVar2,oFocus

oFocus:=SetAppFocus()
oDarea:=oDlg:drawingArea


    @ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT             SIZE oDarea:currentSize()[1],oDarea:currentSize()[2] PIXEL ;  // <-- used to overlay anything over previous window (transparent)
                   COLOR XBPSYSCLR_TRANSPARENT,XBPSYSCLR_TRANSPARENT    OBJECT oBarEdit


    @ 12,30 DCSTATIC TYPE XBPDLG_RAISEDBORDERTHIN   SIZE 30,10 OBJECT oRectangle COLOR NIL,COLOR_TITLE_BG PARENT oBarEdit


    // example of two GETs
    cVar1:=SPACE(10)
    cVar2:=SPACE(15)
    @ 1,2  DCGET cVar1 GETSIZE 10 GETID "GET1" PARENT oRectangle
    @ 3,2  DCGET cVar2 GETSIZE 15              PARENT oRectangle


    /* ---- PUSHBUTTON ---- */
    @ oDarea:currentSize()[2]-37,15 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE oButtonLev0:currentSize()[1],oButtonLev0:currentSize()[2] OBJECT oButtonLev1 PIXEL ;
                             COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON PARENT oBarEdit

        @ 0.3,1  DCPUSHBUTTON CAPTION "GETLIST LEVEL 2" ;
                            ACTION {|| TEST_LEVEL2(GetList,oDialogNew,oButtonLev1) } SIZE 15,1.2 PARENT oButtonLev1 TABSTOP

        @ 0.3,20 DCPUSHBUTTON CAPTION "CLOSE" ;
                            ACCELKEY xbeK_ESC CARGO 'CANCEL' ;
                            ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) } SIZE 15,1.2 PARENT oButtonLev1 TABSTOP



    DCGETOPTIONS  CONFIRM BORDER XBPDLG_NO_BORDER NORESIZE NOTASKLIST NOTITLEBAR NOMINBUTTON NOMAXBUTTON FITPAD 0 HIDE  ;
                  COLOR XBPSYSCLR_TRANSPARENT

    DCREAD GUI  OPTIONS GetOptions FIT MODAL PARENT @oDialogNew ;
                ENTEREXIT OWNER oDarea APPWINDOW oDialog EVAL {|o|o:setPos( { 0, 0 } ) ,o:show()}  HANDLER _handler

    DC_GetDestroy(GetList)


SetAppFocus( oFocus )

RETURN NIL






STATIC FUNCTION TEST_LEVEL2 (oGetList,oDlg,oButtonLev1)
LOCAL GetOptions ,GetList:={}
LOCAL aSize,aPos,nColPos,nRowPos,oColumn,oColumn2,oCell,aRect,nHeadHeight,nRowHeight
LOCAL nT,nX,nY,oBarEdit,oDialogNew
LOCAL oButtonLev2,oRectangle
LOCAL cVar1,cVar2,oFocus

oFocus:=SetAppFocus()
oDarea:=oDlg:drawingArea


    @ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT             SIZE oDarea:currentSize()[1],oDarea:currentSize()[2] PIXEL ;  // <-- used to overlay anything over previous window (transparent)
                   COLOR XBPSYSCLR_TRANSPARENT,XBPSYSCLR_TRANSPARENT  OBJECT oBarEdit


    @ 12,40 DCSTATIC TYPE XBPDLG_RAISEDBORDERTHIN   SIZE 50,8 OBJECT oRectangle COLOR NIL,COLOR_BUTTONS_BG_MOUSEOVER PARENT oBarEdit


    // example of two GETs
    cVar1:=SPACE(10)
    cVar2:=SPACE(15)
    @ 1,2  DCGET cVar1 GETSIZE 10 GETID "GET1" PARENT oRectangle
    @ 3,2  DCGET cVar2 GETSIZE 15              PARENT oRectangle


    /* ---- PUSHBUTTON ---- */
    @ oDarea:currentSize()[2]-37,15 DCSTATIC TYPE XBPSTATIC_TYPE_FGNDRECT SIZE oButtonLev1:currentSize()[1],oButtonLev1:currentSize()[2] OBJECT oButtonLev2 PIXEL ;
                             COLOR COLOR_RECTPBUTTON,COLOR_RECTPBUTTON PARENT oBarEdit

        @ 0.3,1 DCPUSHBUTTON CAPTION "CLOSE" ;
                            ACCELKEY xbeK_ESC CARGO 'CANCEL' ;
                            ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) } SIZE 15,1.2 PARENT oButtonLev2 TABSTOP



    DCGETOPTIONS  CONFIRM BORDER XBPDLG_NO_BORDER RESIZE NOTASKLIST NOTITLEBAR NOMINBUTTON NOMAXBUTTON FITPAD 0 HIDE  ;
                  COLOR XBPSYSCLR_TRANSPARENT

    DCREAD GUI  OPTIONS GetOptions FIT MODAL PARENT @oDialogNew ;
                ENTEREXIT OWNER oDarea APPWINDOW oDialog EVAL {|o|o:setPos( { 0, 0 } ) ,o:show()} HANDLER _handler

    DC_GetDestroy(GetList)



oDialog:paint()

SetAppFocus( oFocus )
oDlg:hide()
oDlg:configure()
oDlg:show()
oDlg:paint()

RETURN NIL




STATIC FUNCTION _Handler( nEvent, mp1, mp2, oXbp, oDlg, GetList )
IF (nEvent == xbeP_Resize .OR. nEvent == xbeP_Move)
    IF ( oDialog:getFrameState() == XBPDLG_FRAMESTAT_MAXIMIZED  .OR.  oDialog:getFrameState() == XBPDLG_FRAMESTAT_MINIMIZED)
        nLastState:=oDialog:getFrameState()
    ELSE
        IF oDialog:getFrameState()==XBPDLG_FRAMESTAT_NORMALIZED.AND.nLastState>0

            *SetAppFocus(oDialog)
            *oDialog:invalidateRect()
            *oDialog:configure()

            *SetAppFocus(oDlg)
            *oDlg:invalidateRect()
            *oDlg:configure()

            oDlg:invalidateRect()
            oDlg:configure()
            *DCMSGBOX str( oDlg:currentSize()[1] )+ str( oDlg:currentSize()[2] ) + IIF(LOK,"OK","na")



        ENDIF
        nLastState:=0
    ENDIF
ENDIF

RETURN DCGUI_NONE


